.\" $XFree86: xc/programs/Xserver/hw/xfree86/drivers/nsc/nsc.man,v 1.1 2002/12/10 15:12:23 alanh Exp $ 
.\" shorthand for double quote that works everywhere.
.ds q \N'34'
.TH NSC __drivermansuffix__ __vendorversion__
.SH NAME
nsc \- Nsc video driver
.SH SYNOPSIS
.nf
.B "Section \*qDevice\*q"
.BI "  Identifier \*q"  devname \*q
.B  "  Driver \*qnsc\*q"
\ \ ...
.B EndSection
.fi
.SH DESCRIPTION
.B nsc
is an XFree86 driver for National Semiconductors GEODE processor family.
It uses the DURANGO kit provided by National Semiconductor.
The driver is accelerated, and provides support for the following 
framebuffer depths: 8, 16 and 24.
.SH SUPPORTED HARDWARE
The
.B nsc
driver supports GXLV (5530 companion chip), SC1200, SC1400 and
GX2 (5535 companion chip).
.SH CONFIGURATION DETAILS
Please refer to XF86Config(__filemansuffix__) for general configuration
details.  This section only covers configuration details specific to this
driver.
.PP
The driver will auto-detect the amount of video memory present for all
chips. If the amount of memory is detected incorrectly, the actual amount
of video memory should be specified with a
.B VideoRam
entry in the config file
.B \*qDevice\*q
section.
.PP
The following driver
.B Options
are supported:
.TP
.BI "Option \*qSWCursor\*q \*q" boolean \*q
Enable or disable the SW cursor.  
Default: off.
.TP
.BI "Option \*qHWCursor\*q \*q" boolean \*q
Enable or disable the HW cursor.  
Default: on.
.TP
.BI "Option \*qNoAccel\*q \*q" boolean \*q
Disable or enable acceleration.  
Default: acceleration is enabled.
.TP
.BI "Option \*qNoCompression\*q \*q" boolean \*q
Disable or enable compression.  
Default: compression is enabled.
.TP
.BI "Option \*qShadowFB\*q \*q" boolean \*q
Enable or disable use of the shadow framebuffer layer.  
Default: off.
.TP
.BI "Option \*qRotate\*q \*qCW\*q"
Rotate the display clockwise. This mode is unaccelerated, and uses
the Shadow Frame Buffer layer.
Default: no rotation.
.TP
.BI "Option \*qRotate\*q \*qCCW\*q"
Rotate the display counterclockwise. This mode is unaccelerated, and
uses the Shadow Frame Buffer layer.
Default: no rotation.
.TP
.BI "Option \*qFlatPanel\*q \*q" boolean \*q
This enables the FlatPanel display unit. The FlatPanel depends on the 
BIOS to do the Pnale h/w initialization.
In GX2 based platforms with TFT part Flatpanel is enabled, and on CRT
part is disabled.
Default: off.
.TP
.BI "Option \*qOSMImageBuffers\*q \*q" integer \*q
This sets the number of scanline buffers to be allocated in offscreen 
memory for acceleration. This can take any value 0 will disable the 
allocation. Disabled if cannot alocate requested scanline memory.
Default: 20.
.TP
.BI "Option \*qColorKey\*q \*q" integer \*q
This sets the default pixel value for the YUV video overlay key.
Default: 0.
.PP
The following 
.B Options
are supported only on SC1200 based platforms:
.TP
.BI "Option \*qTV\*q \*qPAL-768x576\*q"
Selects the PAL TV display mode 768x576 and the depth is forced to 16 bpp.
Default: no TV.
.TP
.BI "Option \*qTV\*q \*qPAL-720x576\*q"
Selects the PAL TV display mode 720x576 and the depth is forced to 16 bpp.
Default: no TV.
.TP
.BI "Option \*qTV\*q \*qNTSC-720x480\*q"
Selects the NTSC TV display mode 720x480 and the depth is forced to 16 bpp.
Default: no TV.
.TP
.BI "Option \*qTV\*q \*qNTSC-640x480\*q"
Selects the NTSC TV display mode 640x480 and the depth is forced to 16 bpp.
Default: no TV.
.TP
.BI "Option \*qTV_Output\*q \*qCOMPOSITE\*q"
The selected TV mode output is coded for Composite signal.
Default: no TV.
.TP
.BI "Option \*qTV_Output\*q \*qSVIDEO\*q"
The selected TV mode output is coded for SVIDEO signal.
Default: no TV.
.TP
.BI "Option \*qTV_Output\*q \*qYUV\*q"
The selected TV mode output is coded for YUV signal.
Default: no TV.
.TP
.BI "Option \*qTV_Output\*q \*qSCART\*q"
The selected TV mode output is coded for SCART signal.
Default: no TV.
.TP
.BI "Option \*qTVOverscan\*q \*xx:yy:ww:hh\*q"
This option will let only the viewable display area smaller to be able to 
view on TV. The parameters xx: X-offset, yy: Y-offset, ww: Viewable width,
hh: Viewable height.
Default: no TV.
.SH "SEE ALSO"
XFree86(1), XF86Config(__filemansuffix__), xf86config(1), Xserver(1), X(__miscmansuffix__)
.SH AUTHOR
Author: Sarma V. Kolluru
