.\"
.\" Copyright  2001 Keith Packard, member of The XFree86 Project, Inc.
.\"
.\" Permission to use, copy, modify, distribute, and sell this software and its
.\" documentation for any purpose is hereby granted without fee, provided that
.\" the above copyright notice appear in all copies and that both that
.\" copyright notice and this permission notice appear in supporting
.\" documentation, and that the name of Keith Packard not be used in
.\" advertising or publicity pertaining to distribution of the software without
.\" specific, written prior permission.  Keith Packard makes no
.\" representations about the suitability of this software for any purpose.  It
.\" is provided "as is" without express or implied warranty.
.\"
.\" KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
.\" EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
.\" DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
.\" TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
.\" PERFORMANCE OF THIS SOFTWARE.
.\"
.\"
.\" $XFree86: xc/programs/xrandr/xrandr.man,v 1.4 2002/10/02 16:58:05 keithp Exp $
.\"
.TH XRANDR 1 "Version 1.0" "XFree86"
.SH NAME
xrandr \- primitive command line interface to RandR extension
.SH SYNOPSIS
.B "xrandr"
[-help]  [-display \fIdisplay\fP]
[-o \fIorientation\fP]
[-q] [-v]
[-s \fIsize\fP]
[-x] [-y]
[--screen \fIsnum\fP]
[--verbose]
.SH DESCRIPTION
.I Xrandr
is uses to set the screen size, orientation and/or reflection.
The
.I -s
option is a small integer index used to specify which size the screen should be set to.
To find out what sizes are available, use the
.I -q
option, which reports the sizes available, the current rotation, and
the possible rotations and reflections.
The default size is the first size specified in the list.
The
.I -o
option is used to specify the orientation of the screen,
and can be one of
\f"Inormal inverted left right 0 1 2 3"\fP.
.PP
The
.I -x
option instructs the server to reflect the screen on the X axis.
The
.I -y
option instructs the server to reflect the screen on the Y axis.
Reflection is applied after rotation.
.PP
The
.I -help
option prints out a usage summary.
The
.I --verbose
option tells you what xrandr is doing, selects for events, and tells you
when events are received to enable debugging.
.SH "SEE ALSO"
Xrandr(3)
.SH AUTHORS
Keith Packard,
XFree86 Core Team and Cambridge Research Laboratory, HP Labs, HP.
and
Jim Gettys, 
Cambridge Research Laboratory, HP Labs, HP.
